
//////////////////////////////////////////////////////////////////////////////////////
// 遅延評価する仮想マシンのようなもの
//////////////////////////////////////////////////////////////////////////////////////

class GNode
{
public:
	// 値が欲しいときはこれを呼ぶ
	Value run() { if(value is null){value=thunk(); thunk=null;} return value; }

	// コンストラクタ
	this( Value v )            { this.value = v; }
	this( Value delegate() t ) { this.thunk = t; }

	// 再帰的定義の処理用の美しくないコンストラクタ
	this() {}
	void set(GNode g) { this.tupleof = g.tupleof; }

private:
	Value            value; // 評価済みならこっち
	Value delegate() thunk; // 未評価ならこっち
}

//////////////////////////////////////////////////////////////////////////////////////
// 値の種類はコンパイラが適当に決める。整数とかfloatとか文字列とか
//////////////////////////////////////////////////////////////////////////////////////

abstract class Value
{
}

//////////////////////////////////////////////////////////////////////////////////////
// 環境 = 名前→ノード
//////////////////////////////////////////////////////////////////////////////////////

alias GNode[string] Env;
