import graph;
import compiler;
import std.stdio;

//////////////////////////////////////////////////////////////////////////////////////
// IO の実装
//////////////////////////////////////////////////////////////////////////////////////

void performIO( GNode g )
{
	Value v = g.run;
	if( auto v = AS_TAG(v, "PRINT") )
	{
		foreach(m; v.mem)
			writeln( m.run );
	}
	else
	if( auto v = AS_TAG(v, "SEQIO") )
	{
		foreach(m; v.mem)
			performIO( m );
	}
	else
	if( auto v = AS_TAG(v, "NOP") )
	{
	}
	else
	{
		throw new RuntimeFail("unknown io operation");
	}
}
